class VoidSniperRifle expands TournamentWeapon;

#exec TEXTURE IMPORT NAME=Rifle2a FILE=Textures\Rifle1.bmp GROUP=Skins LODSET=2
#exec TEXTURE IMPORT NAME=Rifle2b FILE=Textures\Rifle2.bmp GROUP=Skins LODSET=2
#exec TEXTURE IMPORT NAME=Rifle2c FILE=Textures\Rifle3.bmp GROUP=Skins LODSET=2
#exec TEXTURE IMPORT NAME=Rifle2d FILE=Textures\Rifle4.bmp GROUP=Skins LODSET=2

#exec TEXTURE IMPORT NAME=UseRifle FILE=Textures\UseRifle.bmp GROUP=Icons LODSET=2
#exec TEXTURE IMPORT NAME=Crosshairsqr FILE=Textures\Crosshairsqr.bmp FLAGS=2 MIPS=OFF
#exec TEXTURE IMPORT NAME=crosshair FILE=Textures\crosshair.bmp FLAGS=2 MIPS=OFF

#exec AUDIO IMPORT FILE="Sounds\Fire.wav" NAME="Fire" GROUP="SniperRifle"
#exec AUDIO IMPORT FILE="sounds\BubbleBlast.WAV" NAME="BubbleBlast" GROUP="SniperRifle"

var int NumFire;
var name FireAnims[5];
var vector OwnerLocation;
var float StillTime, StillStart;
var bool bZoom;

simulated event PostNetBeginPlay()
{
   local Rifle_HUDMutator crosshair;
   local PlayerPawn HUDOwner;

   Super.PostNetBeginPlay();

   // If owner is the local player, check that the HUD Mutator exiists. Also check for the presense of a bbPlayer (UTPure enabled)
   HUDOwner = PlayerPawn(Owner);
   if (HUDOwner != None && HUDOwner.IsA('bbPlayer') && HUDOwner.myHUD != None)
   {
      ForEach AllActors(Class'Rifle_HUDMutator', crosshair)
         break;
      if (crosshair == None)
      {
         crosshair = Spawn(Class'Rifle_HUDMutator', Owner);
         crosshair.RegisterHUDMutator();
         crosshair.HUDOwner = HUDOwner;
      }
   }
}

simulated function PostRender( canvas Canvas )
{
   local PlayerPawn P;
   local float Scale;
   local float Xlength;
   local float range;
   local vector HitLocation, HitNormal, StartTrace, EndTrace, X,Y,Z;
   local actor Other;
   local float radpitch;

   Super.PostRender(Canvas);
   P = PlayerPawn(Owner);
   if ( (P != None) && (P.DesiredFOV != P.DefaultFOV) )
   {
      bOwnsCrossHair = true;

      if ( Level.bHighDetailMode )
         Canvas.Style = ERenderStyle.STY_Translucent;
      else
         Canvas.Style = ERenderStyle.STY_Normal;

		// Scentre
		Canvas.SetPos( 3*Canvas.ClipX/7, 3*Canvas.ClipY/7 );
		Canvas.DrawTile( Texture'Crosshairsqr', Canvas.ClipX/7, Canvas.ClipY/7, 256, 256, 256, 256 );

            // Top Line
            Canvas.SetPos( 200*Canvas.ClipX/401, Canvas.ClipY/229*(90-P.DesiredFOV)+0.6*Canvas.ClipY/28 );
            Canvas.DrawTile( Texture'crosshair', Canvas.ClipX/401, Canvas.ClipY/28, 0, 20, 4, 10 );

		// Bottom Line
		Canvas.SetPos( 200*Canvas.ClipX/401, 15.35*Canvas.ClipY/28 + Canvas.ClipY/229*P.DesiredFOV );
		Canvas.DrawTile( Texture'crosshair', Canvas.ClipX/401, Canvas.ClipY/28, 0, 20, 4, 10 );

		// Left Line
		Canvas.SetPos( Canvas.ClipX/229*(90-P.DesiredFOV)+0.6*Canvas.ClipX/28, 200*Canvas.ClipY/401.5 );
		Canvas.DrawTile( Texture'crosshair', Canvas.ClipX/28, Canvas.ClipY/401.5, 10, 0, 10, 3 );

		// Right Line
		Canvas.SetPos( 15.35*Canvas.ClipX/28 + Canvas.ClipX/229*P.DesiredFOV, 200*Canvas.ClipY/401.5 );
		Canvas.DrawTile( Texture'crosshair', Canvas.ClipX/28, Canvas.ClipY/401.5, 10, 0, 10, 3 );

	      // Top Gradient
            Canvas.SetPos( 200*Canvas.ClipX/400, 4*Canvas.ClipY/9 );
            Canvas.DrawTile( Texture'crosshair', Canvas.ClipX/400, Canvas.ClipY/1360*(90-P.DesiredFOV), 129, 197, 3, 54 );

            // Left Gradient
            Canvas.SetPos( 4*Canvas.ClipX/9, 200*Canvas.ClipY/400 );
            Canvas.DrawTile( Texture'crosshair', Canvas.ClipX/1360*(90-P.DesiredFOV), Canvas.ClipY/400, 69, 200, 54, 3 );

            //Bottom Gradient
            Canvas.SetPos( 200*Canvas.ClipX/400, 5*Canvas.ClipY/9 - Canvas.ClipY/1360*(90-P.DesiredFOV) );
            Canvas.DrawTile( Texture'crosshair', Canvas.ClipX/400, Canvas.ClipY/1360*(90-P.DesiredFOV), 144, 199, 3, 54 );
 
            //Right Gradient
            Canvas.SetPos( 5*Canvas.ClipX/9 - Canvas.ClipX/1360*(90-P.DesiredFOV), 200*Canvas.ClipY/400 );
            Canvas.DrawTile( Texture'crosshair', Canvas.ClipX/1360*(90-P.DesiredFOV), Canvas.ClipY/400, 163, 199, 54, 3 );

            // Top Gradient 2
            Canvas.SetPos( 200*Canvas.ClipX/402.5, 4*Canvas.ClipY/9 );
            Canvas.DrawTile( Texture'crosshair', Canvas.ClipX/402.5, Canvas.ClipY/1360*(90-P.DesiredFOV), 129, 197, 3, 54 );

            // Left Gradient 2
            Canvas.SetPos( 4*Canvas.ClipX/9, 200*Canvas.ClipY/402.5 );
            Canvas.DrawTile( Texture'crosshair', Canvas.ClipX/1360*(90-P.DesiredFOV), Canvas.ClipY/402.5, 69, 200, 54, 3 );

            //Bottom Gradient 2
            Canvas.SetPos( 200*Canvas.ClipX/402.5, 5*Canvas.ClipY/9 - Canvas.ClipY/1360*(90-P.DesiredFOV) );
            Canvas.DrawTile( Texture'crosshair', Canvas.ClipX/402.5, Canvas.ClipY/1360*(90-P.DesiredFOV), 144, 199, 3, 54 );
 
            //Right Gradient 2
            Canvas.SetPos( 5*Canvas.ClipX/9 - Canvas.ClipX/1360*(90-P.DesiredFOV), 200*Canvas.ClipY/402.5 );
            Canvas.DrawTile( Texture'crosshair', Canvas.ClipX/1360*(90-P.DesiredFOV), Canvas.ClipY/402.5, 163, 199, 54, 3 );


		Canvas.DrawColor.R = 0;
		Canvas.DrawColor.G = 0;
		Canvas.DrawColor.B = 0;

	Canvas.Style = ERenderStyle.STY_Normal;
      Scale = Canvas.ClipX/640;
      Canvas.SetPos(0.5 * Canvas.ClipX + 8 * Scale * 0.5, 0.5 * Canvas.ClipY + 80 * Scale * 0.5);
	Canvas.Font = Font'Botpack.WhiteFont';
      Canvas.DrawColor.R = 120;
	Canvas.DrawColor.G = 205;
	Canvas.DrawColor.B = 0;
	Scale = P.DefaultFOV/P.DesiredFOV;
	Canvas.DrawText("[void] Head Piercer");

	Scale = Canvas.ClipX/640;
	Canvas.SetPos(0.5 * Canvas.ClipX + 10 * Scale * 0.5, 0.5 * Canvas.ClipY + 90 * Scale * 0.5);   //x-> -20
	Canvas.Font = Font'Botpack.WhiteFont';
      Canvas.DrawColor.R = 120;
	Canvas.DrawColor.G = 205;
	Canvas.DrawColor.B = 0;
	Scale = P.DefaultFOV/P.DesiredFOV;
	Canvas.DrawText("Zoom: x"$int(Scale)$"."$int(10 * Scale - 10 * int(Scale)));

   }
   else
      bOwnsCrossHair = false;
}

function float RateSelf( out int bUseAltMode )
{
   local float dist;

   if ( AmmoType.AmmoAmount <=0 )
      return -2;

   bUseAltMode = 0;
   if ( (Bot(Owner) != None) && Bot(Owner).bSniping )
      return AIRating + 1.15;
   if (  Pawn(Owner).Enemy != None )
   {
      dist = VSize(Pawn(Owner).Enemy.Location - Owner.Location);
      if ( dist > 1200 )
      {
         if ( dist > 2000 )
            return (AIRating + 0.75);
         return (AIRating + FMin(0.0001 * dist, 0.45));
      }
   }
   return AIRating;
}

// set which hand is holding weapon
function setHand(float Hand)
{
   Super.SetHand(Hand);
   if ( Hand == 1 )
   {
      Mesh = mesh(DynamicLoadObject("Botpack.Rifle2mL", class'Mesh'));
   }
   else
   {
	Mesh = mesh'Rifle2m';
	MultiSkins[0] = Texture'VoidSniperRifleV3.Skins.Rifle2a';
	MultiSkins[1] = Texture'VoidSniperRifleV3.Skins.Rifle2b';
	MultiSkins[2] = Texture'VoidSniperRifleV3.Skins.Rifle2c';
	MultiSkins[3] = Texture'VoidSniperRifleV3.Skins.Rifle2d';
   }
}
/*
function DropFrom(vector StartLocation)
{
   Destroy();
}
*/
simulated function PlayFiring()
{
   local int r;

   PlayOwnedSound(FireSound, SLOT_None, Pawn(Owner).SoundDampening*3.0);
   if ( (Owner.Physics != PHYS_Falling && Owner.Physics != PHYS_Swimming && Pawn(Owner).bDuck != 0)
      || Owner.Velocity == 0 * Owner.Velocity )
      PlayAnim(FireAnims[Rand(5)],3.5 + 3.5 * FireAdjust, 0.09);
   else
      PlayAnim(FireAnims[Rand(5)],0.3 + 0.3 * FireAdjust, 0.03);

   if ( (PlayerPawn(Owner) != None)
      && (PlayerPawn(Owner).DesiredFOV == PlayerPawn(Owner).DefaultFOV) )
      bMuzzleFlash++;
}

simulated function bool ClientAltFire( float Value )
{
   GotoState('Zooming');
   return true;
}

function AltFire( float Value )
{
   ClientAltFire(Value);
}

function Fire( float Value )
{
   if ( (AmmoType == None) && (AmmoName != None) )
   {
      // ammocheck
      GiveAmmo(Pawn(Owner));
   }
   if ( AmmoType.UseAmmo(1) )
   {
      GotoState('NormalFire');
      bPointing=True;
      bCanClientFire = true;
      ClientFire(Value);
      if ( bRapidFire || (FiringSpeed > 0) )
         Pawn(Owner).PlayRecoil(FiringSpeed);
      if ( bInstantHit )
      {
         if ( (Owner.Physics != PHYS_Falling && Owner.Physics != PHYS_Swimming && Pawn(Owner).bDuck != 0)
            || Owner.Velocity == 0 * Owner.Velocity )
            TraceFire(0.0);
         else
            TraceFire(46);
      }
      else
         ProjectileFire(ProjectileClass, ProjectileSpeed, bWarnTarget);
   }
}


state NormalFire
{
   function EndState()
   {
      Super.EndState();
      OldFlashCount = FlashCount;
   }

Begin:
      FlashCount++;
}

function Timer()
{
   local actor targ;
   local float bestAim, bestDist;
   local vector FireDir;
   local Pawn P;

   bestAim = 0.95;
   P = Pawn(Owner);
   if ( P == None )
   {
      GotoState('');
      return;
   }
   if ( VSize(P.Location - OwnerLocation) < 6 )
      StillTime += FMin(2.0, Level.TimeSeconds - StillStart);

   else
      StillTime = 0;
   StillStart = Level.TimeSeconds;
   OwnerLocation = P.Location;
   FireDir = vector(P.ViewRotation);
   targ = P.PickTarget(bestAim, bestDist, FireDir, Owner.Location);
   if ( Pawn(targ) != None )
   {
      SetTimer(1 + 4 * FRand(), false);
      bPointing = true;
      Pawn(targ).WarnTarget(P, 200, FireDir);
   }
   else
   {
      SetTimer(0.4 + 1.6 * FRand(), false);
      if ( (P.bFire == 0) && (P.bAltFire == 0) )
         bPointing = false;
   }
}

function ProcessTraceHit(Actor Other, Vector HitLocation, Vector HitNormal, Vector X, Vector Y, Vector Z)
{


   if (Other == Level)
      Spawn(class'UT_HeavyWallHitEffect',,, HitLocation+HitNormal, Rotator(HitNormal));
   else if ( (Other != self) && (Other != Owner) && (Other != None) )
   {
      if ( Other.bIsPawn )
      {
         Other.PlaySound(Sound 'ChunkHit',, 4.0,,100);
         Other.PlaySound(Sound 'UnrealI.Razorjack.BladeThunk',, 4.0,,100);
         PlayOwnedSound(Sound 'UnrealI.Razorjack.BladeThunk',, 4.0,,10);
      }
      if ( Other.bIsPawn && (HitLocation.Z - Other.Location.Z > 0.62 * Other.CollisionHeight)
      && (instigator.IsA('PlayerPawn') || (instigator.IsA('Bot') && !Bot(Instigator).bNovice))
      && ((Owner.Physics != PHYS_Falling && Owner.Physics != PHYS_Swimming && Pawn(Owner).bDuck != 0)
      || Owner.Velocity == 0 * Owner.Velocity) )
      {
         if ( Pawn(Other).Health > 0 )
         {
            Other.TakeDamage(100000, Pawn(Owner), HitLocation, 35000 * X, AltDamageType);

            if ( Pawn(Other).Health < 1
                && (!Level.Game.bTeamGame || Pawn(Owner).PlayerReplicationInfo.Team != Pawn(Other).PlayerReplicationInfo.Team) )
               AmmoType.AddAmmo(3);
         }
         else
            Other.TakeDamage(100000, Pawn(Owner), HitLocation, 35000 * X, AltDamageType);
      }
      else
         Other.TakeDamage(30,  Pawn(Owner), HitLocation, 30000.0*X, MyDamageType);

      if ( !Other.bIsPawn && !Other.IsA('Carcass') )
         spawn(class'UT_SpriteSmokePuff',,,HitLocation+HitNormal*9);
   }
}

function Finish()
{
   if ( (Pawn(Owner).bFire!=0) && (FRand() < 0.6) )
      Timer();
   Super.Finish();
}

function TraceFire( float Accuracy )
{
   local vector HitLocation, HitNormal, StartTrace, EndTrace, X,Y,Z;
   local actor Other;
   local Pawn PawnOwner;

   PawnOwner = Pawn(Owner);

   Owner.MakeNoise(PawnOwner.SoundDampening);
   GetAxes(PawnOwner.ViewRotation,X,Y,Z);
   StartTrace = Owner.Location + PawnOwner.Eyeheight * Z;
   AdjustedAim = PawnOwner.AdjustAim(1000000, StartTrace, 2*AimError, False, False);
   EndTrace = StartTrace + Accuracy * (FRand() - 0.5 )* Y * 1000
      + Accuracy * (FRand() - 0.5 ) * Z * 1000;
   X = vector(AdjustedAim);
   EndTrace += (100000 * X);
   Other = PawnOwner.TraceShot(HitLocation,HitNormal,EndTrace,StartTrace);
   ProcessTraceHit(Other, HitLocation, HitNormal, X,Y,Z);
}


state Idle
{
   function Fire( float Value )
   {
      if ( AmmoType == None )
      {
         // ammocheck
         GiveAmmo(Pawn(Owner));
      }
      if (AmmoType.UseAmmo(1))
      {
         GotoState('NormalFire');
         bCanClientFire = true;
         bPointing=True;
         if ( Owner.IsA('Bot') )
         {
            // simulate bot using zoom
            if ( Bot(Owner).bSniping && (FRand() < 0.65) )
               AimError = AimError/FClamp(StillTime, 1.0, 8.0);
            else if ( VSize(Owner.Location - OwnerLocation) < 6 )
               AimError = AimError/FClamp(0.5 * StillTime, 1.0, 3.0);
            else
               StillTime = 0;
         }
         Pawn(Owner).PlayRecoil(FiringSpeed);
         if ( (Owner.Physics != PHYS_Falling && Owner.Physics != PHYS_Swimming && Pawn(Owner).bDuck != 0)
            || Owner.Velocity == 0 * Owner.Velocity )
            TraceFire(0.0);
         else
            TraceFire(46);
         AimError = Default.AimError;
         ClientFire(Value);
      }
   }


   function BeginState()
   {
      bPointing = false;
      SetTimer(0.4 + 1.6 * FRand(), false);
      Super.BeginState();
   }

   function EndState()
   {
      SetTimer(0.0, false);
      Super.EndState();
   }

Begin:
   bPointing=False;
   if ( AmmoType.AmmoAmount<=0 )
      Pawn(Owner).SwitchToBestWeapon(); 
   if ( Pawn(Owner).bFire!=0 ) Fire(0.0);
   Disable('AnimEnd');
   PlayIdleAnim();
}

state Zooming
{
   simulated function Tick(float DeltaTime)
   {
      if ( Pawn(Owner).bAltFire == 0 )
      {
         bZoom = false;
         SetTimer(0.0,False);
         GoToState('Idle');
      }
      else if ( bZoom )
      {
         if ( PlayerPawn(Owner).DesiredFOV > 3.0 )
         {
            PlayerPawn(Owner).DesiredFOV -= PlayerPawn(Owner).DesiredFOV*DeltaTime*4;
         }

         if ( PlayerPawn(Owner).DesiredFOV <=3.0 )
         {
            PlayerPawn(Owner).DesiredFOV = 3.0;
            bZoom = false;
            SetTimer(0.0,False);
            GoToState('Idle');
         }
      }
   }

   simulated function BeginState()
   {
      if ( Owner.IsA('PlayerPawn') )
      {
         if ( PlayerPawn(Owner).DesiredFOV == PlayerPawn(Owner).DefaultFOV )
         {
            bZoom = true;
            SetTimer(0.2,True);
         }
         else if ( bZoom == false )
         {
            PlayerPawn(Owner).DesiredFOV = PlayerPawn(Owner).DefaultFOV;
            Pawn(Owner).bAltFire = 0;
         }
      }
      else
      {
         Pawn(Owner).bFire = 1;
         Pawn(Owner).bAltFire = 0;
         Global.Fire(0);
      }
   }
}

simulated function PlayIdleAnim()
{
   if ( Mesh != PickupViewMesh )
      PlayAnim('Still',1.0, 0.05);
}

defaultproperties
{
    FireAnims(0)=Fire
    FireAnims(1)=Fire2
    FireAnims(2)=Fire3
    FireAnims(3)=Fire4
    FireAnims(4)=Fire5
    WeaponDescription="[void] Sniper Rifle."
    AmmoName=Class'VoidAmmo'
    PickupAmmoCount=200
    bInstantHit=True
    bAltInstantHit=True
    FiringSpeed=1.30
    FireOffset=(X=0.00,Y=-5.00,Z=-2.00),
    MyDamageType=shot
    AltDamageType=Decapitated
    shakemag=400.00
    shaketime=0.15
    shakevert=8.00
    AIRating=0.54
    RefireRate=0.30
    AltRefireRate=0.30
    FireSound=Sound'VoidSniperRifleV3.SniperRifle.Fire'
    AltFireSound=Sound'UnrealShare.AutoMag.shot'
    SelectSound=Sound'VoidSniperRifleV3.SniperRifle.BubbleBlast'
    DeathMessage="%k slaughtered %o."
    NameColor=(R=0,G=0,B=255,A=0),
    bDrawMuzzleFlash=True
    MuzzleScale=1.00
    FlashY=0.11
    FlashO=0.01
    FlashC=0.03
    FlashLength=0.01
    FlashS=256
    MFTexture=Texture'Botpack.Rifle.MuzzleFlash2'
    AutoSwitchPriority=5
    InventoryGroup=10
    PickupMessage="You picked up a [void] Sniper Rifle."
    ItemName="VoidSniperRifle"
    PlayerViewOffset=(X=5.00,Y=-1.60,Z=-1.70),
    PlayerViewMesh=LodMesh'Botpack.Rifle2m'
    PlayerViewScale=2.00
    BobDamping=0.98
    PickupViewMesh=LodMesh'VoidSniperRifleV3.PickupmeshH'
    ThirdPersonMesh=LodMesh'VoidSniperRifleV3.PickupmeshP'
    StatusIcon=Texture'VoidSniperRifleV3.Icons.UseRifle'
    MuzzleFlashMesh=LodMesh'Botpack.muzzsr3'
    MuzzleFlashScale=0.10
    MuzzleFlashTexture=Texture'Botpack.Skins.Muzzy3'
    PickupSound=Sound'UnrealShare.Pickups.WeaponPickup'
    Icon=Texture'VoidSniperRifleV3.Icons.UseRifle'
    Rotation=(Pitch=0,Yaw=0,Roll=-1536),
    Mesh=LodMesh'VoidSniperRifleV3.PickupmeshP'
    bNoSmooth=False
    CollisionRadius=32.00
    CollisionHeight=8.00
}
